#!/usr/bin/python
import os,re,time,sys,textwrap
from argparse import ArgumentParser as AP
from argparse import RawTextHelpFormatter as ADHF

class c:
	#colors
  RED="\033[31m"
  R="\033[31m"
  GREEN="\033[32m"
  G="\033[32m"
  YELLOW="\033[33m"
  Y="\033[33m"
  BLUE="\033[34m"
  B="\033[34m"
  BOLD="\033[1m"
  F="\033[1m"

	#formats
  BOLD="\033[1m"
  _B="\033[1m"
  ITALIC="\033[3m"
  _I="\033[3m"
  UNDERLINE="\033[4m"
  _U="\033[4m"
  BLINK="\033[5m"
  _BL="\033[5m"
  INVERSE="\033[7m"
  _IV="\033[7m"
  STRIKE="\033[9m"
  _ST="\033[9m"

	#no format
  OFF="\033[0m"
  _="\033[0m"

desc=textwrap.dedent(c._B+'''\
ioBroker JSON-file Tree builder based on targeted OID.
Easily create multiple directories in one step based on the breadcrumb of an OID.

'''+c.Y+'''Example:
\t'''+c._I+sys.argv[0]+''' -o 0_userdata.0.neuer.Baum'''+c._+'''

'''+c.Y+c._B+'''Ergebnis in ioBroker:'''+c.G+'''
\t0_userdata
\t └0
\t  └neuer
\t   └Baum'''+c._
)

prs = AP(description=desc,formatter_class=ADHF)
prs.add_argument("-o", "--oid", nargs='?', required=True, dest="oid", action="append", help="Zu beschreibende OID, kann mehrfach aufgeführt werden")
prs.add_argument("-f", "--force", dest="isForce", action="store_true", help="Auch außerhalb von 0_Userdata zulassen")
args = prs.parse_args()

#Übernehme Argumente
aOids=args.oid
isForce=args.isForce

#Prüfe, ob OID außerhalb von 0_Userdata liegt, wenn ja, brech ab, außer '--force'
def checkIsDangerous(aOids):
	isDangerous=False
	for sOid in aOids: isDangerous=isDangerous or (re.search("^0_userdata\.\d",sOid)==None)
	
	if(isDangerous and not(isForce)):
		sErr=c.R+c._B+c._U+"Fehler:"+c._+c.R+"""\n
Die gewünschte OID ist außerhalb der Benutzerbereiche und potentiell gefährlich!!
Wenn Sie wissen was Sie tun, nutzen Sie bitte --force.
Breche ab..."""+c._
		sys.exit(sErr)

iNow = round(time.time()*1000)

###########################
## Hauptlogik: Klopfe alle gefunden Elemente ab und erstelle die JSON Elemente

checkIsDangerous(aOids)

print("{")
iSize1=len(aOids)

for h in range(0,iSize1):
	sOid=aOids[h]
	sBcr=""
	aDirs=sOid.split(".")
	iSize2=len(aDirs)
	for i in range(0,iSize2):
		sDir=aDirs[i]

		# Baue Breadcrumb
		sBcr+="."+sDir if (sBcr) else sDir
		
		if(not(isForce)):
			# Überspringe 0_userdata-root + Instanz
			if (re.search("^0_userdata(\.\d)?$", sBcr)!=None): continue

		print('"'+sBcr+'''": {
	"common": { "name": "'''+sBcr+'''" },
	"type": "folder",
	"_id": "'''+sBcr+'''",
	"acl": {
		"object": 1604,
		"owner": "system.user.admin",
		"ownerGroup": "system.group.administrator"
	},
	"from": "system.adapter.admin.0",
	"user": "system.user.admin",
	"ts": '''+str(iNow))
		print('''	}''') if((h==iSize1-1) and (i==iSize2-1)) else print('''	},''')
print("}")
